
#include "colors.inc"        
#include "stones.inc"
#include "glass.inc"



camera { orthographic location <0,0,-8>*2   look_at <0,0,0> angle 20      rotate 2*y  }//  
                 

light_source {<-8,15,-10>*10 White  shadowless}                  
          //    area_light  <4,0,0>, <0,0,4>,4, 4                jitter }
light_source {<4,30,-20>*5 White shadowless}   
 light_source {<4,-18,-10>*30 rgb <1,0.7,0.2> shadowless}                   
             
background {Black} // White}   //  
//================================
#declare base=array[1] { <0,0,0>};   //  le bon dpart{<0,0,-0.5>}; // AMUSANT !  
//array[8]{<1,-1,-1>,<1,-1,1>,<-1,-1,1>,<-1,-1,-1>,<-1,1,-1>,<-1,1,1>,<1,1,1>,<1,1,-1>};
//================================

#declare r=0.2;
#declare dmax=pow(8,6);
#declare T=array[dmax];   // resultat final
#declare T1=array[dmax/8];  // sauvegarde du rsultat prcedent
#declare T2=array[dmax/8];  // tableau de travail
//============manip de tableaux ============ 
#macro renv(L,p)
   #declare cp2=0;
   #while (cp2<p/2)
       #declare tp=L[cp2];
       #declare L[cp2]=L[p-cp2-1];
       #declare L[p-cp2-1]=tp;
       #declare cp2=cp2+1;
   #end
#end //renv 
//---------------------------- 
// copie les n premires cases de L dans M  partir du rang deb
#macro copy(L,M,p,deb) 
   #declare cp1=0;
   #while (cp1<p)
       #declare M[deb+cp1]=L[cp1];
       #declare cp1=cp1+1;
   #end
#end //copy
//============================
       
#macro rx(w,s) <w.x,-s*w.z,s*w.y> #end
#macro ry(w,s) <-s*w.z,w.y,s*w.x> #end 
#macro rz(w,s) <s*w.y,-s*w.x,w.z> #end      


#macro tr1(pt) rx(pt*0.5,-1) + <1,-1,-1> #end
#macro tr2(pt) rz(pt*0.5,1) + <1,-1,1> #end 
#macro tr3(pt) pt*0.5 + <-1,-1,1> #end
#macro tr4(pt) rz(rx(pt*0.5,-1),-1) + <-1,-1,-1> #end
#macro tr5(pt) rz(rx(pt*0.5,1),1) + <-1,1,-1> #end
#macro tr6(pt) pt*0.5 + <-1,1,1> #end
#macro tr7(pt) rz(pt*0.5,-1) + <1,1,1> #end
#macro tr8(pt) rx(pt*0.5,1) + <1,1,-1> #end
//============================
#macro graf(L,n,ro) 
     union{
     #declare cp=0;
     #while(cp<n-1)
         cylinder{L[cp], L[cp+1], ro} 
         sphere{L[cp],ro}
         #declare cp=cp+1;
     #end
     sphere{L[n-1],ro} 
     }
#end   

//============================ 
   
#macro peano(n,ro) 
   //copy(base,T,8,0)
   copy(base,T,1,0)
   
   #declare cp=0;
   #while (cp<n)
              #declare nb=pow(8,cp);
              
              copy(T,T2,nb,0) 
              #declare na=0;         //similitude 1 -------------
              #while (na<nb)
                    #declare T1[na]=tr1(T2[na]);   #declare na=na+1;
              #end
              renv(T1,nb) copy(T1,T,nb,0)       
              #declare na=0;         //similitude 2 -------------
              #while (na<nb)
                    #declare T1[na]=tr2(T2[na]);   #declare na=na+1;
              #end
              renv(T1,nb)   copy(T1,T,nb,nb)       
              #declare na=0;        //similitude 3 -------------
              #while (na<nb)
                    #declare T1[na]=tr3(T2[na]);    #declare na=na+1;
              #end
              copy(T1,T,nb,2*nb)
              #declare na=0;        //similitude 4 -------------
              #while (na<nb)
                    #declare T1[na]=tr4(T2[na]);    #declare na=na+1;
              #end
              copy(T1,T,nb,3*nb)       
              #declare na=0;        //similitude 5 -------------
              #while (na<nb)
                    #declare T1[na]=tr5(T2[na]);   #declare na=na+1;
              #end
              copy(T1,T,nb,4*nb)      
              #declare na=0;         //similitude 6 -------------
              #while (na<nb)
                    #declare T1[na]=tr6(T2[na]);   #declare na=na+1;
              #end
              copy(T1,T,nb,5*nb)       
              #declare na=0;        //similitude 7 -------------
              #while (na<nb)
                    #declare T1[na]=tr7(T2[na]);    #declare na=na+1;
              #end
              renv(T1,nb)   copy(T1,T,nb,6*nb)       
              #declare na=0;        //similitude 8 -------------
              #while (na<nb)
                    #declare T1[na]=tr8(T2[na]);     #declare na=na+1;
              #end
              renv(T1,nb)    copy(T1,T,nb,7*nb)
       
              #declare cp=cp+1;
              
       #end //while(cp)
 
graf(T,pow(8,n),ro) 
 
 #end    
   
//=============
#declare boite=   // box{-2,2 pigment{Cyan} } ;
                intersection{  box{-2,2 } box{-1.97,1.97 inverse}
                               texture{ T_Glass3
                                        finish { ambient 0.4 diffuse 0.1 reflection 0.1 specular 0.8} 
                                                 }
                               interior { ior Crown_Glass_Ior}    //ior Air_Ior }
         };
//====================
 
    
#declare total=
union{ object{boite}
    object{ peano(2,0.03)  pigment{Cyan}    }
   object{ peano(1,0.06)  pigment{rgb <1,0.7,0>*1.1 }   } /* */
                scale 0.75 // scale 0.5*x
  rotate <-12,-15,3>} ;
  // ========= avec render 2048x768 ( pas terrible ! ) =========================
/*  union{  
  object{total  translate -1.415*x} 
  object{total rotate 1.9*y translate 1.415*x} 
  finish { ambient 0.5 diffuse 0.2  specular 0.8}                                       
  }
  */ 
 
   object{total  scale 1.1  
  finish { ambient 0.5 diffuse 0.2  specular 0.8}                                       
  }         
              
 